Index: /trunk/gli/src/org/greenstone/gatherer/cdm/FormatManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/FormatManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,58 +25,27 @@
  *########################################################################
  */
-
- 
-
-
-
-
-/* GPL_HEADER */
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Company:      The University of Waikato
- * Written:        /05/02
- * Revised:      04/10/02 - Commented
+ * Written:     06/05/02
+ * Revised:     04/10/02 - Commented
+ *              14/07/03 - DOM support
  **************************************************************************************/
-import java.awt.BorderLayout;
-import java.awt.CardLayout;
-import java.awt.Color;
-import java.awt.Dimension;
-import java.awt.GridLayout;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.KeyAdapter;
-import java.awt.event.KeyEvent;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.Vector;
-import javax.swing.BorderFactory;
-import javax.swing.BoxLayout;
-import javax.swing.ButtonGroup;
-import javax.swing.DefaultComboBoxModel;
-import javax.swing.JButton;
-import javax.swing.JCheckBox;
-import javax.swing.JComboBox;
-import javax.swing.JLabel;
-import javax.swing.JList;
-import javax.swing.JPanel;
-import javax.swing.JScrollPane;
-import javax.swing.JTabbedPane;
-import javax.swing.JTextArea;
-import javax.swing.JTextField;
-import javax.swing.JToggleButton;
-import javax.swing.ListSelectionModel;
-import javax.swing.event.ListSelectionEvent;
-import javax.swing.event.ListSelectionListener;
+import java.awt.*;
+import java.awt.event.*;
+import java.util.*;
+import javax.swing.*;
+import javax.swing.event.*;
 import org.greenstone.gatherer.Gatherer;
 import org.greenstone.gatherer.cdm.Classifier;
 import org.greenstone.gatherer.cdm.ClassifierManager;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
 import org.greenstone.gatherer.cdm.CollectionDesignManager;
 import org.greenstone.gatherer.cdm.CommandTokenizer;
-import org.greenstone.gatherer.cdm.DynamicListModel;
+import org.greenstone.gatherer.cdm.Control;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.cdm.Format;
 import org.greenstone.gatherer.msm.ElementWrapper;
 import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
 /** This class maintains a list of format statements, and allows the addition and removal of these statements.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
@@ -94,25 +53,21 @@
  */
 public class FormatManager
-    extends DynamicListModel {
-    /** The main manager so we can get to ClassifierManager which is needed to turn position reference such as "CL1" into the appropriate Classifier. */
-    private CollectionDesignManager manager = null;
+    extends DOMProxyListModel {
+
     /** The controls used to edit the format commands. */
     private Control controls = null;
     /** A reference to ourselves so inner classes can get at the model. */
-    private DynamicListModel model = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
-    /** We may have somehow recieved a format command which references a classifier that hasn't been parsed yet, so this variable holds a list of failed commands which are retried after the loading is complete. */
-    private Vector unresolved_commands = null;
-    /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong>.
-     * @param manager A reference to the <strong>CollectionDesignManager</strong> that created this manager.
-     */
-    public FormatManager(Gatherer gatherer, CollectionDesignManager manager) {
-	super();
-	this.gatherer = gatherer;
-	this.manager = manager;
+    private DOMProxyListModel model = null;
+
+    /** Constructor. */
+    public FormatManager() {
+	super(CollectionDesignManager.collect_config.getDocumentElement(), CollectionConfiguration.FORMAT_ELEMENT, new Format());
 	this.model = this;
-	this.unresolved_commands = new Vector();
+	Gatherer.println("FormatManager: parsed " + getSize() + " format statements.");
+	// Establish all of the format objects, so that classifier indexes are initially correct (subsequent refreshes of the model will be sufficient to keep these up to date, as long as we start with a live reference to a classifier.
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    getElementAt(i);
+	}
     }
     /** Method to add a new format to this manager.
@@ -120,237 +75,75 @@
 	  */
     public void addFormat(Format format) {
-	if(formatExists(format) == null) {
-	    addElement(format);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
-    /** Method which determines if a certain format exists, in which case it must be removed before a new format of the same component is added. For general formatting statements this compares types, for 'custom' ones it compares list and part.
-	  * @param format The <strong>Format</strong> whose uniqueness we want to check.
-	  * @return The <strong>Format</strong> that matches the one given, or <i>null</i> if no such format exists.
-	  */
-    public Format formatExists(Format format) {
-	for(int i = 0; i < size(); i++) {
-	    Format current = (Format) get(i);
-	    if(format.getPosition().equals(current.getPosition())) {
-		return current;
-	    }
-	}
-	return null;
-    }
+	if(!contains(format)) {
+	    Element element = format.getElement();
+	    // Locate where we should insert this new classifier. 
+	    Node target_node = CollectionConfiguration.findInsertionPoint(element);
+	    add(root, format, target_node);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+    }
+
     /** Gets the format indicated by the index.
-	  * @param index The location of the desired format, as an <i>int</i>.
-	  */
+     * @param index The location of the desired format, as an <i>int</i>.
+     */
     public Format getFormat(int index) {
-	return (Format)get(index);
-    }
+	Format result = null;
+	if(0 < index && index < getSize()) {
+	    result = (Format) getElementAt(index);
+	}
+	return result;
+    }
+    
     /** Method to retrieve this managers controls.
-	  * @return The <strong>Control</strong> for this collection.
-	  */
+     * @return the Control for this collection.
+     */
     public Control getControls() {
 	if(controls == null) {
-	    controls = new Control();
+	    controls = new FormatControl();
 	}
 	return controls;
     }
-    /** Method to invalidate controls when some significant change has occured within the collection. */
-    public void invalidateControls() {
-	if(controls != null) {
-	    controls.destroy();
-	}
-	controls = null;
-    }
-    /** This method attempts to parse a format command from the given string. If a format is parsed, it is immediately added to this managers list of format commands.
-	  * @param command The <strong>String</strong> we are trying to parse a command from.
-	  * @param finished A <i>boolean</i> which is <i>true</i> if we are calling this after the the input has been completely parsed (i.e all legal Classifiers are know to exist), or <i>false</i> otherwise.
-	  * @return A <i>boolean</i> which is <i>true</i> if we managed to parse a command, <i>false</i> otherwise.
-	  * @see org.greenstone.gatherer.cdm.Classifier
-	  * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	  * @see org.greenstone.gatherer.cdm.Format
-	  */
-    public boolean parse(String command, boolean finished) {
-	String temp = command.toLowerCase();
-	if(temp.startsWith("format")) {
-	    if(finished) {
-		CommandTokenizer ct = new CommandTokenizer(command);
-		ct.nextToken(); // Throw away 'format'
-		String position = ct.nextToken();
-		String value = ct.nextToken();
-		// String speech marks.
-		if(value.startsWith("\"") && value.endsWith("\"")) {
-		    if(value.equals("\"\"")) {
-			value = "";
-		    }
-		    else {
-			value = value.substring(1, value.length() - 1);
-		    }
-		}
-		// Ensure we parsed a good command.
-		if(position != null && value != null) {
-		    // The trickiest bit of parsing format commands is figuring out how much of the position is feature, and how much part. Since the parts are far less likely to change or be customized in any way, we'll try to match them first (except "" of course).
-		    String feature_name = null;
-		    String part = null;
-		    // If this works, then we're all finished. Yay.
-		    for(int i = 1; i < Format.DEFAULT_PARTS.length; i++) {
-			if(position.endsWith(Format.DEFAULT_PARTS[i])) {
-			    part = Format.DEFAULT_PARTS[i];
-			    feature_name = position.substring(0, position.length() - part.length());
-			}
-		    }
-		    // Otherwise we can attempt to find the default features, but we have less chance of success.
-		    if(feature_name == null || part == null) {
-			for(int i = 1; i < Format.DEFAULT_FEATURES.length; i++) {
-			    if(position.startsWith(Format.DEFAULT_FEATURES[i])) {
-				feature_name = Format.DEFAULT_FEATURES[i];
-				if(position.length() > feature_name.length()) {
-				    part = position.substring(feature_name.length());
-				}
-				else {
-				    part = "";
-				}
-			    }
-			}
-		    }
-		    // Otherwise we can assume we are dealing with a classifier and split the position using...
-		    // position            ::= <classifier_position><part>
-		    // classifier_position ::= <alphanum>[0-9]$
-		    // part                ::= ^![0-9]<alpha>
-		    // But I don't like my chances of this working if someone does a scary like CL4Part8B. I just have
-		    // to hope no-one uses numbers, and no-one expects CustomFeatureCustomPart to parse properly.
-		    if(feature_name == null || part == null) {
-			part = "";
-			boolean found = false;
-			int index = position.length() - 1;
-			while(index >= 0 && !found) {
-			    if(Character.isDigit(position.charAt(index))) {
-				found = true;
-			    }
-			    else {
-				part = position.charAt(index) + part;
-				index--;
-			    }
-			}
-			if(found) {
-			    feature_name = position.substring(0, index + 1);
-			}
-			// We ran out of string. No digits. Arg!
-			else {
-			    part = null;
-			}
-		    }
-		    // And if all else fails, stick it all in feature.
-		    if(feature_name == null || part == null) {
-			feature_name = position;
-			part = "";
-		    }
-		    // Now try to retrieve a classifier with the feature name.
-		    Object feature = null;
-		    String feature_name_lc = feature_name.toLowerCase();
-		    if(feature_name_lc.startsWith("cl") && feature_name.length() >= 3) {
-			String raw_index = feature_name.substring(2); // Lose the 'CL'
-			int index = -1;
-			try {
-			    index = Integer.parseInt(raw_index);
-			}
-			catch(NumberFormatException nfe) {
-			    nfe.printStackTrace();
-			}
-			feature = manager.classifiers.getClassifier(index - 1);
-		    }
-		    else {
-			///ystem.err.println("name to short for classifier.");
-		    }
-		    if(feature == null) {
-			feature = feature_name;
-		    }
-		    ///ystem.err.println("Feature name = " + feature_name + "\nPart = " + part);
-		    if(feature instanceof Classifier) {
-			///ystem.err.println("Feature is a classifier.");
-		    }
-		    else {
-			///ystem.err.println("Feature is a String.");
-		    }
-		    // Now we have a quick look at value. If its true or false we create a FLAG type
-		    if(value.equalsIgnoreCase("true")) {
-			addFormat(new Format(feature, part, true));
-		    }
-		    else if(value.equalsIgnoreCase("false")) {
-			addFormat(new Format(feature, part, false));
-		    }
-		    // Otherwise add a plain old value based format
-		    else {
-			addFormat(new Format(feature, part, value));
-		    }
-		    return true;
-		}
-		// Somethings gone terribly, terribly wrong.
-		return false;
-	    }
-	    else {
-		// Ensure we have enough tokens for a format command
-		CommandTokenizer ct = new CommandTokenizer(command);
-		while(ct.countTokens() < 3) {
-		    command = manager.parseMore(command);
-		    ct = new CommandTokenizer(command);
-		}
-		unresolved_commands.add(command);
-	    }
-	    return true;
-	}
-	return false;
-    }
+
     /** Method to remove a format.
-	  * @param format The <strong>Format</strong> to remove.
-	  */
+     * @param format The <strong>Format</strong> to remove.
+     */
     public void removeFormat(Format format) {
-	removeElement(format);
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method which attempts to reparse obvious format commands which previously referenced unresovable Classifiers.
-	*/
-    public void reparseUnresolved() {
-	for(int i = 0; i < unresolved_commands.size(); i++) {
-	    if(!parse((String)unresolved_commands.get(i), true)) {
-		///ystem.err.println("*** Error: Command " + unresolved_commands.get(i));
-	    }
-	}
-	// Regardless of if they work, clear the commands.
-	unresolved_commands.clear();
-    }
-    /** Method to produce a block of text representing the format commands in this manager, ready to be used in the collection configuration file.
-	* @return A <strong>String</strong> containing a series of format commands.
-	*/
-    public String toString() {
-	StringBuffer text = new StringBuffer("");
-	for(int i = 0; i < size(); i++) {
-	    Format format = (Format) get(i);
-	    text.append(format.toString());
-	    text.append("\n");
-	}
-	text.append("\n");
-	return text.toString();
-    }
+	remove(format);
+	Gatherer.c_man.configurationChanged();
+    }
+
     /** Overloaded to call get with both a key and an empty argument array.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  */
+     * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
+     * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
+     */
     private String get(String key) {
 	return get(key, null);
     }
+
     /** Used to retrieve a property value from the Locale specific ResourceBundle, based upon the key and arguments supplied. If the key cannot be found or if some other part of the call fails a default (English) error message is returned. <BR>
-	  * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.Dictionary
-	  */
+     * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
+     * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
+     * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
+     * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.Dictionary
+     */
     private String get(String key, String args[]) {
 	if(key.indexOf('.') == -1) {
 	    key = "CDM.FormatManager." + key;
 	}
-	return gatherer.dictionary.get(key, args);
-    }
-    private class Control
-	extends JPanel {
+	return Gatherer.dictionary.get(key, args);
+    }
+
+    private class FormatControl
+	extends JPanel 
+	implements Control {
 	/** Do we ignore selection changing events (mainly because we're generating them!) */
 	private boolean ignore = false;
@@ -404,15 +197,6 @@
 	private Vector part_model = null;
 	private Vector special_model = null;
-	public Control() {
-	    ArrayList feature_model = new ArrayList();
-				// Add the set options
-	    for(int i = 0; i < Format.DEFAULT_FEATURES.length; i++) {
-		feature_model.add(new Entry(Format.DEFAULT_FEATURES[i]));
-	    }
-				// Now the classifiers.
-	    for(int j = 0; j < manager.classifiers.size(); j++) {
-		feature_model.add(new Entry(manager.classifiers.getClassifier(j)));
-	    }
-	    Collections.sort(feature_model);
+	public FormatControl() {
+	    ArrayList feature_model = buildFeatureModel();
 	    part_model = new Vector();
 	    part_model.add("");//get("Custom"));
@@ -430,10 +214,10 @@
 	    special_model.add("[parent(Top):_]");
 	    special_model.add("[parent(All'_'):_]");
-	    Vector elements = gatherer.c_man.msm.getAssignedElements();
+	    Vector elements = Gatherer.c_man.getCollection().msm.getAssignedElements();
 	    for(int i = 0; i < elements.size(); i++) {
 		special_model.add("[" + ((ElementWrapper)elements.get(i)).toString() + "]");
 	    }
 	    Collections.sort(special_model);
-				// Create
+	    // Create
 	    add = new JButton(get("Add"));
 	    add.setEnabled(false);
@@ -443,8 +227,8 @@
 	    control_pane = new JPanel();
 	    editor = new JTextArea();
-	    editor.setBackground(Color.white);
+	    editor.setBackground(Gatherer.config.getColor("coloring.editable", false));
 	    editor.setCaretPosition(0);
 	    editor.setLineWrap(true);
-	    editor.setWrapStyleWord(true);
+	    editor.setWrapStyleWord(false);
 	    editor_label = new JLabel(get("Editor"));
 	    editor_label.setHorizontalAlignment(JLabel.CENTER);
@@ -496,9 +280,9 @@
 	    value_pane = new JPanel();
 	    view_pane = new JPanel();
-				// Connect
+	    // Connect
 	    add.addActionListener(new AddListener());
 	    button_group.add(on);
 	    button_group.add(off);
-	    editor.addKeyListener(new EditorListener());
+	    editor.getDocument().addDocumentListener(new EditorListener());
 	    feature.addActionListener(new FeatureListener());
 	    format_list.addListSelectionListener(new FormatListListener());
@@ -596,33 +380,53 @@
 	    ready = true;
 	}
+
 	public void destroy() {
 	}
+
 	/** Overriden to ensure that the instructions pane is scrolled to the top.
-			*/
-	public void updateUI() {
+	 */
+	public void gainFocus() {
+	    // This is only necessary if the components have been realized
 	    if(ready) {
-		// Rebuild feature model.
-		ArrayList feature_model = new ArrayList();
-		// Add the set options
-		for(int i = 0; i < Format.DEFAULT_FEATURES.length; i++) {
-		    feature_model.add(new Entry(Format.DEFAULT_FEATURES[i]));
-		}
-		// Now the classifiers.
-		for(int j = 0; j < manager.classifiers.size(); j++) {
-		    feature_model.add(new Entry(manager.classifiers.getClassifier(j)));
-		}
+		model.refresh();
+		ArrayList feature_model = buildFeatureModel();
+		// Remember the current selection
+		Object selected_object = feature.getSelectedItem();
 		feature.setModel(new DefaultComboBoxModel(feature_model.toArray()));
+		// Now resotre the selected object as best as possible
+		feature.setSelectedItem(selected_object);
 		if(instructions != null) {
 		    instructions.setCaretPosition(0);
 		}
-	    }
-	    super.updateUI();
-	}
-
-
+	    }   
+	}
+
+	public void loseFocus() {
+	    // Force all of the Formats to update their names with the correct values.
+	    int size = model.getSize();
+	    for(int i = 0; i < size; i++) {
+		Format format = (Format) model.getElementAt(i);
+		format.update();
+	    }
+	}
+
+	private ArrayList buildFeatureModel() {
+	    // Rebuild feature model.
+	    ArrayList feature_model = new ArrayList();
+	    // Add the set options
+	    for(int i = 0; i < Format.DEFAULT_FEATURES.length; i++) {
+		feature_model.add(new Entry(Format.DEFAULT_FEATURES[i]));
+	    }
+	    // Now the classifiers.
+	    for(int j = 0; j < CollectionDesignManager.classifier_manager.getSize(); j++) {
+		feature_model.add(new Entry(CollectionDesignManager.classifier_manager.getClassifier(j)));
+	    }
+	    Collections.sort(feature_model);
+	    return feature_model;
+	}
 
 	/** Formats the formatting string so that it contains safe characters and isn't enclosed in speech marks etc. (Ironic eh?)
-			* @see java.lang.StringBuffer
-			*/
+	 * @see java.lang.StringBuffer
+	 */
 	private String format(String raw) {
 	    String safe = null;
@@ -665,9 +469,10 @@
 	    return raw;
 	}
+
 	/** Listens for clicks on the add button, and if the relevant details are provided adds a new format. */
 	private class AddListener
 	    implements ActionListener {
 	    public void actionPerformed(ActionEvent event) {
-		ignore = true;
+		//ignore = true;
 		Entry entry = (Entry)feature.getSelectedItem();
 		Object f = entry.getFeature();
@@ -685,10 +490,24 @@
 		format_list.setSelectedValue(current_format, true);
 		new_entry = false;
-		ignore = false;
-	    }
-	}
+		//ignore = false;
+	    }
+	}
+
 	private class EditorListener
-	    extends KeyAdapter {
-	    public void keyReleased(KeyEvent event) {
+	    implements DocumentListener {
+ 
+	    public void changedUpdate(DocumentEvent e) {
+		update();
+	    }
+          
+	    public void insertUpdate(DocumentEvent e) {
+		update();
+	    }
+          
+	    public void removeUpdate(DocumentEvent e) {
+		update();
+	    }
+
+	    public void update() {
 		String safe = format(editor.getText());
 		if(!ignore && current_format != null) {
@@ -700,6 +519,6 @@
 			current_format.setValue("");
 		    }
-		    gatherer.c_man.configurationChanged();
-		    model.refresh();
+		    Gatherer.c_man.configurationChanged();
+		    model.refresh(current_format);
 		}
 		Entry entry = (Entry) feature.getSelectedItem();
@@ -713,4 +532,5 @@
 	    }
 	}
+
 	/** This object provides a wrapping around an entry in the format target control, which is tranparent as to whether it is backed by a String or a Classifier. */
 	private class Entry
@@ -781,4 +601,5 @@
 	    }
 	}
+
 	private class FeatureListener
 	    implements ActionListener {
@@ -788,7 +609,5 @@
 		    Entry entry = (Entry) feature.getSelectedItem();
 		    String name = entry.toString();
-		    int type = Format.getType(name);
-		    switch(type) {
-		    case Format.FLAG:
+		    if(Format.isParamType(name)) {
 			// Flags first.
 			part.setEnabled(false);
@@ -797,6 +616,6 @@
 			view_type = FLAG;
 			add.setEnabled(true); // One of the options must be selected.
-			break;
-		    default:
+		    }
+		    else {
 			part.setEnabled(true);
 			part_pane.add(part, BorderLayout.CENTER);
@@ -815,4 +634,5 @@
 	    }
 	}
+
 	private class FormatListListener
 	    implements ListSelectionListener {
@@ -825,9 +645,28 @@
 			Entry an_entry = new Entry(current_format.getFeature());
 			feature.setSelectedItem(an_entry);
-			// Try to match the part.
-			part.setSelectedItem(current_format.getPart());
+			// If we didn't match anything, add it and select it again
+			Entry result_entry = (Entry) feature.getSelectedItem();
+			if(!an_entry.equals(result_entry)) {
+			    feature.insertItemAt(an_entry, feature.getItemCount());
+			    feature.setSelectedItem(an_entry);
+			}
+			
+			if(current_format.canHavePart()) {
+			    part.setEnabled(true);
+			    // Try to match the part.
+			    String part_entry = current_format.getPart();
+			    part.setSelectedItem(part_entry);
+			    // If we didn't match anything, add it and select it again
+			    String selected_part = (String)part.getSelectedItem();
+			    if(!part_entry.equals(selected_part)) {
+				part.insertItemAt(part_entry, part.getItemCount());
+				feature.setSelectedItem(part_entry);
+			    }
+			}
+			else {
+			    part.setEnabled(false);
+			}
 			// Now use type to determine what controls are visible, and what have initial values.
-			switch(current_format.getType()) {
-			case Format.FLAG:
+			if(current_format.isParamType()) {
 			    // Flags first.
 			    part.setEnabled(false);
@@ -839,6 +678,6 @@
 			    off.setSelected(!current_format.getState());
 			    add.setEnabled(false); // Can only update
-			    break;
-			default:
+			}
+			else {
 			    part.setEnabled(true);
 			    part_pane.add(part, BorderLayout.CENTER);
@@ -907,5 +746,5 @@
 		    // We have just performed an edit. Immediately update the format and model.
 		    current_format.setState(on.isSelected());
-		    model.refresh();
+		    model.refresh(current_format);
 		}
 	    }
@@ -917,5 +756,5 @@
 		    // We have just performed an edit. Immediately update the format and model.
 		    current_format.setValue(value.getText());
-		    model.refresh();
+		    model.refresh(current_format);
 		}
 	    }
